/*
 * PCN Abstract Machine Emulator
 * Authors:     Steve Tuecke and Ian Foster
 *              Argonne National Laboratory
 *
 * Please see the DISCLAIMER file in the top level directory of the
 * distribution regarding the provisions under which this software
 * is distributed.
 *
 * sr_ce.h  -  send/receive header for Cosmic Environment
 */

#undef PARALLEL
#define PARALLEL

#undef ASYNC_MSG
#define ASYNC_MSG 0

#undef SR_CE
#define SR_CE


/* maximum number of nodes */
#ifndef MAX_NODES
#define MAX_NODES	512
#endif

/*
 * The PCN message types
 */
#define MSG_DEFINE		10000001
#define MSG_VALUE		10000002
#define MSG_READ		10000003
#define MSG_CANCEL		10000004
#define MSG_COLLECT		10000005
#define MSG_INITIATE_EXIT	10000006
#define MSG_EXIT		10000007
#define MSG_PARAMS		10000008
#define MSG_ABORT		10000009
#define MSG_GAUGE		10000010
